function bin(k: longint): string;
var
	r: string;
begin
	r := '';
	while k > 0 do begin
		r := '01'[k mod 2 + 1] + r;
		k := k div 2;
	end;
	bin := copy(r, 2, length(r) - 1);
end;

var
	i, j, k, n: longint;

begin
	randseed := 364894843;
	n := 12;
	k := 0;
	writeln(n);
	for i := 0 to n do begin
		for j := 1 to 1 shl i do begin
			inc(k);
			writeln('+-'[random(2) + 1] + bin(k));
		end;
	end;
end.